Loading...
Searching...
No Matches
CFMap Class Reference

class CFMap More...

`#include <cf_map.h>`

## Public Member Functions

| CFMap ()
| CFMap (const CanonicalForm &s)
| CFMap (const Variable &v)
| CFMap (const Variable &v, const CanonicalForm &s)
| ~CFMap ()
| CFMap (const CFList &L)
| CFMap::CFMap ( const CFList & L ).
| CFMap (const CFMap &m)
CFMap & | operator= (const CFMap &m)
| CFMap & CFMap::operator = ( const CFMap & m ).
void | newpair (const Variable &v, const CanonicalForm &s)
| void CFMap::newpair ( const Variable & v, const CanonicalForm & s )
CanonicalForm | operator() (const CanonicalForm &f) const
| CanonicalForm CFMap::operator () ( const CanonicalForm & f ) const.
| CFMap ()
| CFMap (const CanonicalForm &s)
| CFMap (const Variable &v)
| CFMap (const Variable &v, const CanonicalForm &s)
| ~CFMap ()
| CFMap (const CFList &L)
| CFMap (const CFMap &m)
CFMap & | operator= (const CFMap &m)
void | newpair (const Variable &v, const CanonicalForm &s)
CanonicalForm | operator() (const CanonicalForm &f) const
| CFMap ()
| CFMap (const CanonicalForm &s)
| CFMap (const Variable &v)
| CFMap (const Variable &v, const CanonicalForm &s)
| ~CFMap ()
| CFMap (const CFList &L)
| CFMap (const CFMap &m)
CFMap & | operator= (const CFMap &m)
void | newpair (const Variable &v, const CanonicalForm &s)
CanonicalForm | operator() (const CanonicalForm &f) const

## Private Attributes

MPList | P

## Friends

OSTREAM & | operator<< (OSTREAM &s, const CFMap &m)
| OSTREAM & operator << ( OSTREAM & s, const CFMap & m ).
OSTREAM & | operator<< (OSTREAM &s, const CFMap &m)
| OSTREAM & operator << ( OSTREAM & s, const CFMap & m ).
OSTREAM & | operator<< (OSTREAM &s, const CFMap &m)
| OSTREAM & operator << ( OSTREAM & s, const CFMap & m ).

## Detailed Description

class CFMap

class CFMap - class to map canonical forms.

Use an object of class CFMap to insert 'values' into canonical form. Such a mapping is defined by a list of MapPairs (V -> S) describing which canonical form S to insert for variable V. Hereby, the substituted canonical forms are not subject to further substitutions.

P: list of MapPairs, sorted by level in descending order

Definition at line 84 of file cf_map.h.

## Constructor & Destructor Documentation

## CFMap() [1/18]

CFMap::CFMap | ( |  | ) |

inline

Definition at line 89 of file cf_map.h.

{}

## CFMap() [2/18]

CFMap::CFMap | ( | const CanonicalForm & | s | ) |

inline

Definition at line 90 of file cf_map.h.

: P( MapPair( Variable(), s ) ) {}
CFMap::P
MPList P
Definition cf_map.h:87
s
const CanonicalForm int s
Definition facAbsFact.cc:51

## CFMap() [3/18]

CFMap::CFMap | ( | const Variable & | v | ) |

inline

Definition at line 91 of file cf_map.h.

: P( MapPair( v, 1 ) ) {}
v
const Variable & v
< [in] a sqrfree bivariate poly
Definition facBivar.h:39

## CFMap() [4/18]

CFMap::CFMap | ( | const Variable & | v,
|  | const CanonicalForm & | s )

inline

Definition at line 92 of file cf_map.h.

: P( MapPair( v, s ) ) {}

## ~CFMap() [1/3]

CFMap::~CFMap | ( |  | ) |

inline

Definition at line 93 of file cf_map.h.

{}

## CFMap() [5/18]

CFMap::CFMap | ( | const CFList & | L | ) |

CFMap::CFMap ( const CFList & L ).

CFMap::CFMap() - construct a CFMap from a CFList.

Variable[i] will be mapped to CFList[i] under the resulting map.

Definition at line 63 of file cf_map.cc.

{
CFListIterator i;
int j;
for ( i = L, j = 1; i.hasItem(); i++, j++ )
P.insert( MapPair( Variable(j), i.getItem() ) );
}
i
int i
Definition cfEzgcd.cc:132
j
int j
Definition facHensel.cc:110
CFListIterator
ListIterator< CanonicalForm > CFListIterator
Definition factory.h:537

## CFMap() [6/18]

CFMap::CFMap | ( | const CFMap & | m | ) |

inline

Definition at line 95 of file cf_map.h.

: P( m.P ) {}
m
int m
Definition cfEzgcd.cc:128

## CFMap() [7/18]

CFMap::CFMap | ( |  | ) |

inline

Definition at line 1007 of file factory.h.

{}

## CFMap() [8/18]

CFMap::CFMap | ( | const CanonicalForm & | s | ) |

inline

Definition at line 1008 of file factory.h.

: P( MapPair( Variable(), s ) ) {}

## CFMap() [9/18]

CFMap::CFMap | ( | const Variable & | v | ) |

inline

Definition at line 1009 of file factory.h.

: P( MapPair( v, 1 ) ) {}

## CFMap() [10/18]

CFMap::CFMap | ( | const Variable & | v,
|  | const CanonicalForm & | s )

inline

Definition at line 1010 of file factory.h.

: P( MapPair( v, s ) ) {}

## ~CFMap() [2/3]

CFMap::~CFMap | ( |  | ) |

inline

Definition at line 1011 of file factory.h.

{}

## CFMap() [11/18]

CFMap::CFMap | ( | const CFList & | L | ) |

## CFMap() [12/18]

CFMap::CFMap | ( | const CFMap & | m | ) |

inline

Definition at line 1013 of file factory.h.

: P( m.P ) {}

## CFMap() [13/18]

CFMap::CFMap | ( |  | ) |

inline

Definition at line 1007 of file factory.h.

{}

## CFMap() [14/18]

CFMap::CFMap | ( | const CanonicalForm & | s | ) |

inline

Definition at line 1008 of file factory.h.

: P( MapPair( Variable(), s ) ) {}

## CFMap() [15/18]

CFMap::CFMap | ( | const Variable & | v | ) |

inline

Definition at line 1009 of file factory.h.

: P( MapPair( v, 1 ) ) {}

## CFMap() [16/18]

CFMap::CFMap | ( | const Variable & | v,
|  | const CanonicalForm & | s )

inline

Definition at line 1010 of file factory.h.

: P( MapPair( v, s ) ) {}

## ~CFMap() [3/3]

CFMap::~CFMap | ( |  | ) |

inline

Definition at line 1011 of file factory.h.

{}

## CFMap() [17/18]

CFMap::CFMap | ( | const CFList & | L | ) |

## CFMap() [18/18]

CFMap::CFMap | ( | const CFMap & | m | ) |

inline

Definition at line 1013 of file factory.h.

: P( m.P ) {}

## Member Function Documentation

## newpair() [1/3]

void CFMap::newpair | ( | const Variable & | v,
|  | const CanonicalForm & | s )

void CFMap::newpair ( const Variable & v, const CanonicalForm & s )

CFMap::newpair() - insert a MapPair into a CFMap.

Definition at line 120 of file cf_map.cc.

{
P.insert( MapPair( v, s ), cmpfunc, insfunc );
}
insfunc
static void insfunc(MapPair &orgp, const MapPair &newp)
static void insfunc ( MapPair & orgp, const MapPair & newp )
Definition cf_map.cc:109
cmpfunc
static int cmpfunc(const MapPair &p1, const MapPair &p2)
static int cmpfunc ( const MapPair & p1, const MapPair & p2 )
Definition cf_map.cc:93

## newpair() [2/3]

void CFMap::newpair | ( | const Variable & | v,
|  | const CanonicalForm & | s )

## newpair() [3/3]

void CFMap::newpair | ( | const Variable & | v,
|  | const CanonicalForm & | s )

## operator()() [1/3]

CanonicalForm CFMap::operator() | ( | const CanonicalForm & | f | ) | const

CanonicalForm CFMap::operator () ( const CanonicalForm & f ) const.

CFMap::operator () - apply CO to f.

See subsrec() for more detailed information.

Definition at line 178 of file cf_map.cc.

{
MPListIterator i = P;
return subsrec( f, i );
}
subsrec
static CanonicalForm subsrec(const CanonicalForm &f, const MPListIterator &i)
static CanonicalForm subsrec ( const CanonicalForm & f, const MPListIterator & i )
Definition cf_map.cc:136
f
FILE * f
Definition checklibs.c:9
MPListIterator
ListIterator< MapPair > MPListIterator
Definition factory.h:987

## operator()() [2/3]

CanonicalForm CFMap::operator() | ( | const CanonicalForm & | f | ) | const

## operator()() [3/3]

CanonicalForm CFMap::operator() | ( | const CanonicalForm & | f | ) | const

## operator=() [1/3]

CFMap & CFMap::operator= | ( | const CFMap & | m | ) |

CFMap & CFMap::operator = ( const CFMap & m ).

CFMap::operator = - assignment operator.

Definition at line 77 of file cf_map.cc.

{
if ( this != &m )
P = m.P;
return *this;
}

## operator=() [2/3]

CFMap & CFMap::operator= | ( | const CFMap & | m | ) |

## operator=() [3/3]

CFMap & CFMap::operator= | ( | const CFMap & | m | ) |

## Friends And Related Symbol Documentation

## operator<< [1/3]

OSTREAM & operator<< | ( | OSTREAM & | s,
|  | const CFMap & | m )

friend

OSTREAM & operator << ( OSTREAM & s, const CFMap & m ).

operator << - print a CFMap ("( V[1] -> S[1], ..., V[n] -> * S[n] )".

Definition at line 190 of file cf_map.cc.

{
m.P.print(s);
return s;
}

## operator<< [2/3]

OSTREAM & operator<< | ( | OSTREAM & | s,
|  | const CFMap & | m )

friend

OSTREAM & operator << ( OSTREAM & s, const CFMap & m ).

operator << - print a CFMap ("( V[1] -> S[1], ..., V[n] -> * S[n] )".

Definition at line 190 of file cf_map.cc.

{
m.P.print(s);
return s;
}

## operator<< [3/3]

OSTREAM & operator<< | ( | OSTREAM & | s,
|  | const CFMap & | m )

friend

OSTREAM & operator << ( OSTREAM & s, const CFMap & m ).

operator << - print a CFMap ("( V[1] -> S[1], ..., V[n] -> * S[n] )".

Definition at line 190 of file cf_map.cc.

{
m.P.print(s);
return s;
}

## Field Documentation

## P

MPList CFMap::P

private

Definition at line 87 of file cf_map.h.

The documentation for this class was generated from the following files:

- factory/cf_map.h
- factory/factory.h
- factory/include/factory/factory.h
- factory/cf_map.cc